from skbuild import setup

# Scikit-build requires some options to be passed in the call to `setup()`.
# Hence, these cannot be set in `pyproject.toml`. For details, please refer to
# https://scikit-build.readthedocs.io/en/latest/usage.html#setuptools-options.
setup(
    packages=[
        "RMextract",
        "RMextract.EMM",
        "RMextract.LOFAR_TOOLS",
        "RMextract.pyiri",
        "RMextract.pyiriplas",
    ],
    include_package_data=False,
    package_data={
        "RMextract.EMM": ["*.COF"],
        # Add *.pyf files. These files are _not_ treated as source files by Numpy's setup(),
        # because, normally, they are (re)generated by f2py from the Fortran source files.
        # However, since these files needed to be tweaked a bit, they _must_ be treated as source
        # files now. So, we have to manually add them to the source distribution.
        "RMextract.pyiri": ["iri.pyf", "*.dat", "*.asc"],
        "RMextract.pyiriplas": ["iriplas.pyf", "*.dat", "*.asc", "kp*", "*.ASC"],
    },
)
